<?php

namespace Drupal\synpay\Hook;

use Drupal\Core\Form\FormStateInterface;
use Drupal\commerce_payment\Entity\PaymentGateway;

/**
 * CheckoutFormAlter.
 */
class CheckoutFormAlter {

  /**
   * Hook From Alter.
   */
  public static function hook(&$form, FormStateInterface $form_state, $form_id) {
    // Step 1 Order Information.
    if ($form['#step_id'] == 'order_information') {
    }
    // Step 2 Review.
    if ($form['#step_id'] == 'review') {
      $uri = explode('/', \Drupal::request()->getRequestUri());
      $orders = \Drupal::entityTypeManager()
        ->getStorage('commerce_order')
        ->loadByProperties(['order_id' => $uri[2]]);
      foreach ($orders as $order) {
        if (!empty($order->get('payment_gateway')->getValue())) {
          $pluginConfiguration = $order->get('payment_gateway')->entity->getPluginConfiguration();
          if ($pluginConfiguration['mode'] == 'test') {
            switch ($pluginConfiguration['gateway']) {
              case 'tinkoff':
                $text = "<div><b>У Вас тестовый логин.<br>
                Карта для \"Успешного платежа\":<br>
                Номер: 4300 0000 0000 0777, Срок действия: 11/22, CVC2/CVV2 код: любой<br>
                Карта для \"Неуспешного платежа\":<br>
                Номер: 5000 0000 0000 0009, Срок действия: 11/22, CVC2/CVV2 код: любой</b></div>";
                break;

              default:
                $text = "<div><b>У Вас тестовый логин.<br>
                Карта для использования:<br>
                Номер: 4111 1111 1111 1111, Срок действия: 12/24, CVC2/CVV2 код: 123, Пароль: 12345678</b></div>";
                break;
            }
            $text = '<div class="field__item">' . $text . '</div><br>';
            $form['review']['payment_information']['summary']['payment_gateway']['#prefix'] = $text;
          }
        }
      }
    }
    // Step 3 Payment.
    if ($form['#step_id'] == 'payment') {
      // $form['#suffix'] = 'Робокасса';
    }
    // Step 4 Complete.
    if ($form['#step_id'] == 'complete') {

    }
  }

}
